//========= Copyright  1996-2002, Valve LLC, All rights reserved. ============
//
// Purpose: 
//
// $NoKeywords: $
//=============================================================================

#ifndef INFO_CUSTOMTECH_H
#define INFO_CUSTOMTECH_H
#ifdef _WIN32
#pragma once
#endif

#include "entityoutput.h"
#include "baseentity.h"

//-----------------------------------------------------------------------------
// Purpose: Map entity that adds a custom technology to the techtree
//-----------------------------------------------------------------------------
class CInfoCustomTechnology : public CPointEntity
{
	DECLARE_CLASS( CInfoCustomTechnology, CPointEntity );
public:
	void	Spawn( void );
	void	Activate( void );
	void	UpdateTechPercentage( float flPercentage );
	virtual bool ShouldTransmit( const edict_t *recipient, const void *pvs, int clientArea );

	DECLARE_SERVERCLASS();
	DECLARE_DATADESC();

public:
	COutputFloat m_flTechPercentage;	// Percentage of the tech that's owned
	string_t	 m_iszTech;
	string_t	 m_iszTechTreeFile;

	// Sent via datatable
	CNetworkString( m_szTechTreeFile, 128 );
};

#endif // INFO_CUSTOMTECH_H
